/****************************** MODULE HEADER *******************************
**  module name : door.c
**  autor       : m.herweg@gmx.de
**  description : 
**
**  version     : V0.4   vom 11.11.2000               
**  --------------------------------------------------------------------------
**  known bugs: * blocking read, kein timeout
**                rolf's version macht das besser, ist aber ungetestet
**              * sauberer whre es, alle Teile in C zu schreiben
**                aber das Perl-C Gespann scheint erstmal zu funktionieren
**              * man sollte Konstanten in ein header-File auslagern
**              * eine funktion "3 Befehlsbyte senden" wrde redundanten Code 
**                in open_door und read_card ersetzen
** 	        * /dev/ttyS0 oder /dev/ttyS1 fest einkompiliert
**
**	HISTORY: 0.4	baudrate wird gesetzt
**
**  --------------------------------------------------------------------------
 *
 *  Copyright (C) 2000
 *  Author of this code file: Martin Herweg 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111     
**
******************************** MODULE HEADER *******************************/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>

#include <errno.h>

extern int errno;
// extern FILE *stderr;

#define   OK       0
#define   NK      -1

#define BAUD_RATE    B19200             /* Baudrate (termios)   */



static char *fname = "/dev/ttyS0";
//static  char *fname ="huhu" ;         



/******  main **********************************/

int
main (int argc, char *argv[])
/* argc ist mindestens 1 */
/* argv[0] ist der programmname */
/* argv[1] ist der/die erste Parameter/Option */
{
  int rc = OK;
  char buf1[80];
  char buf2[80];
  char zeichen;
  struct termios tty;
  int rf, fd, mask_old, n, i, ret;

  if (argc != 2)
    {
      fprintf (stderr, "so geht das nicht\n");
      return (-1);
    }



  switch (argv[1][1])
    {

    case 'r':
      do
	ret = read_card ();
      while (ret != 0);
      break;
    case 'o':
      open_door ();
      break;
    default:
      fprintf (stderr, "so geht das nicht\n");
      return (-1);

    }				/* switch */


  return (0);
}				/*main */

//********************************************************************

read_card ()
{
  int c_len = 3, in_len = 9;
  unsigned char command[c_len];
  unsigned char expect[c_len];
  int rc, fd, n;
  unsigned char in_zeichen;
  unsigned char inbuf[in_len];


  command[0] = 0x2A;
  command[1] = 0x16;		//command um 9-stellige kartennummer zu lesen
  command[2] = 0xBB;
  expect[0] = 0xBB;
  expect[1] = 0x16;
  expect[2] = 0xBB;
/* command[0] = 'l';
  command[1] = 'e';
 command[2] = 's';
 expect[0]='l';
 expect[1]='e';
 expect[2]='s';  */

  fd = open_tty ();
// flush_input(fd);

  fprintf (stderr, "read_card hat open gemacht & wartet auf ein \"+\" \n");

// wenn ein + kommt, warte 2 sekunden und versuche dann zu lesen
  do
    {
      read (fd, &in_zeichen, 1);
      fprintf (stderr, "1:%c\n", in_zeichen);
    }
  while (in_zeichen != '+');


  sleep (2);
  fprintf (stderr, "ok   \n");


// 3 stelliger Befehl wird gesendet und exakte Antwort-Bytes erwatet
  for (n = 0; n < c_len; n++)
    {
      fprintf (stderr, "read_card %d ->", command[n]);
      rc = write (fd, &command[n], 1);

      read (fd, &in_zeichen, 1);
      fprintf (stderr, "%d ", in_zeichen);
      if (in_zeichen != expect[n])
	{
	  fprintf (stderr, "NOT OK, I expected %d ! \n ", expect[n]);
	  close (fd);
	  return (-1);
	}
      else
	fprintf (stderr, " OK\n");
    }

// nun 9-stellige Karten ID einlesen.

  for (n = 0; n < in_len; n++)
    {
      // hier whre ein timeout ganz nett ;-)
      read (fd, &inbuf[n], 1);
      // nach stdout ausgeben, hier nimmt es das perl-programm entgegen :    
      printf ("%X:", inbuf[n]);
    }
  printf ("\n");

  close (fd);
  return (0);
}				/*read_card */

//********************************************************************
open_door ()
{
  int c_len = 3;
  unsigned char command[c_len];
  unsigned char expect[c_len];
  int rc, fd, n;
  unsigned char in_zeichen;

  command[0] = 0x2A;
  command[1] = 8;
  command[2] = 0xBB;
  expect[0] = 0xBB;
  expect[1] = 8;
  expect[2] = 0xBB;
//  command[0] = 'a';
//  command[1] = 'b';
//  command[2] = 'c';

  fd = open_tty ();

  fprintf (stderr, "open_door hat open_tty gemacht & sendet nun 3 Bytes \n");

  for (n = 0; n < c_len; n++)
    {

      fprintf (stderr, "open_door %d ->", command[n]);
      rc = write (fd, &command[n], 1);

      read (fd, &in_zeichen, 1);	//blockierend auf antwortzeichen warten
      fprintf (stderr, "%d ", in_zeichen);
      if (in_zeichen != expect[n])
	{
	  fprintf (stderr, "NOT OK, I expected %d ! \n ", expect[n]);
	  close (fd);
	  return (-1);
	}
      else
	fprintf (stderr, " OK\n");


    }				//for

  close (fd);
  return (0);
}				// open_door

//****************************************************************************
open_tty ()
{
  int fd;
  struct termios tty;

  if ((fd = open (fname, O_RDWR)) < 0)
    {
      fprintf (stderr, " kann nicht ffnen \n");
      exit (-1);
    }
  else
    {
      memset (&tty, '\0', sizeof (tty));

      tty.c_cc[VMIN] = 1;	// controlchars: 0 whre nonblocking
      // 1 wartet offensichtlich auf mindestens 1 zeichen
      tty.c_cc[VTIME] = 10;	//   
      tty.c_oflag = 0;		//output modes
      tty.c_lflag = 0;		//local modes

      tty.c_cflag &= ~(CSIZE | CSTOPB | PARENB);	// control modes
      tty.c_cflag |=  BAUD_RATE | CS8 | CREAD;	// 8 data bits, enable receiver
      tty.c_cflag |= CLOCAL;	                // ignore modem control lines
      tty.c_iflag = IGNBRK | IGNPAR;	        // input flags
      // |ISTRIP whre: strip off eighth bit  ?!
      tty.c_lflag &= ~ICANON;	                // non-canonical mode
      tty.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHOKE);	//kein echo machen

      tcdrain (fd);
      if (tcsetattr (fd, TCSANOW, &tty) < 0)
	fprintf (stderr, "tcsetattr hat nicht geklappt\n");

      return (fd);
    }				// else

}				//open_tty

// das braucht man nur fr non-blocking read:
flush_input (int fd)
{
  char buf[1];
  while (read (fd, buf, 1) == 1);
}
